#include <stdio.h>
#include <string.h>

// Find dups in  hashes in john test suite 'input' files, and removes the dupes.

char Lines[2600][256];
int nLines;
int hash_len=16;

int Same(int i, int j) {
   char *cp1 = strchr(Lines[i], ':');
   char *cp2 = strchr(Lines[j], ':');
   if (!cp1 || !cp2)
      return 0;
   if (!strncmp(cp1, cp2, hash_len+2))
      return 1;
   return 0;

}

int FixLM() {
   FILE *in = fopen("LM.in", "r");
   FILE *out = fopen("LM_tst.in", "w");
   char Line[256];
   fgets(Line, 256, in);
   fputs(Line, out);
   fgets(Line, 256, in);
   while (strncmp(Line, "u1499-LM", 8) && !feof(in)) {
      fputs(Line, out);
	  fgets(Line, 256, in);
   }
   // fix last line.
   //"u1499-LM:1499:fc6c598a16340af9d0b5fbdbf3cba1c5:1499:0:SKIPPINAB1499::"  
   memcpy(&Line[14+16], &Line[14], 16);
   memcpy(&Line[14+16], &Line[14], 16);
   strcpy(&Line[61], "SKIPPIN::");
   fprintf (out, "%s\n", Line);
   fclose(in); fclose(out);
   return 0;
}
int main(int argc, char **argv)
{
   FILE *in;
   int i, j, cnt;
   char *FName;
  
   if (argc == 2 && !strcmp(argv[1], "FixLM"))
      return FixLM();

   if (argc > 1)
      FName = argv[1];
   if (argc > 2)
      sscanf(argv[2], "%d", &hash_len);

   in = fopen(FName, "rt");
   if (!in) return printf ("Error opening file %s\n",FName);

   fgets(Lines[nLines], 256, in);
   fputs(Lines[nLines], stdout);
  
   fgets(Lines[nLines], 256, in);
   strtok(Lines[nLines++], "\r\n");
   while (!feof(in))
   {
      fgets(Lines[nLines], 256, in);
      if (feof(in))
         break;
      strtok(Lines[nLines++], "\r\n");
   }
   fclose(in);
   //printf ("Got %d lines\n", nLines);
   for (i = cnt = 0; cnt < 1500; ++i) {
	  if (Lines[i][0] == 0)
		continue;
	  if (strstr(Lines[i], "\\x{039c}"))
	    continue;
      for (j = i+1; j < nLines; ++j) {
         if (Same(i,j)) {
            //return printf("%d same as %d\n%s\n%s\n", i, j, Lines[i], Lines[j]);
			Lines[j][0] = 0;
		}
      }
	  printf ("%s\n", Lines[i]);
	  ++cnt;
   }
   return 0;
}
